#include "fixed.h"

__inline fixed fixedmul(fixed m1,fixed m2)
{
   fixed ret;
	__asm__ __volatile__
	(
		"imul	%%ebx\n"
      "shrd   $12,%%edx,%%eax\n"
//outputs
		: "=a" (ret)
// inputs -
//ax = m1, bx = m2
		:"0" (m1),
		 "b" (m2)
// registers modified
		:   "dx", "di", "cc", "memory"
	 );
	return ret;
}


__inline fixed fixeddiv(fixed d1,fixed d2)
{
   fixed ret;
	__asm__ __volatile__
	(
		".align 4 \n"
    	"cdq \n"
      "shld $12,%%eax,%%edx \n"
      "sall   $12,%%eax \n"
    	"idivl  %%ebx \n"
//outputs
		: "=a" (ret)
// inputs -
//ax = d1, bx = d2
		:"0" (d1),
		 "b" (d2)
// registers modified
		:   "dx", "di", "cc", "memory"
	 );
	return ret;
}
