typedef unsigned long int fixed;

#define FIX_SHIFT    12

#define FIXED_ZERO   0
#define FIXED_ONE    (1<<FIX_SHIFT)
#define FIXED_TWO    (2<<FIX_SHIFT)
#define FIXED_THREE  (3<<FIX_SHIFT)

#define int2fixed(x) ((x) << FIX_SHIFT)
#define fixed2int(x) ((x) >> FIX_SHIFT)
#define fixed2float(x) (((double)(x)) / (1 << FIX_SHIFT))
#define float2fixed(x) ((fixed) (((double)x) * (1 << FIX_SHIFT)))

fixed fixedmul(fixed m1,fixed m2);
fixed fixeddiv(fixed m1,fixed m2);
