#ifndef _GALAGA_VID_H_
#define _GALAGA_VID_H_

#define NORMAL_MODE  0
#define SWITCH_MODE  1

#define GALAGA_NMI_SLICE   8

#define THING 0x90f7
#define THING2 2

#define BCD(x) ((x/10)<<4)|(x%10)

void galagaint(void);
void initgalaga(void);
void cleargalaga(void);
void galagadecodegfx(pBYTE pIn);
void galagasetpal(pBYTE pIn);
void galagaupdatescreen(void);
void galagaint(void);
void galagaint2(void);
void galagaint3(void);
UINT8 galagasharer(UINT32 offset, struct MemoryReadByte *mrb);
UINT8 galagacustr(UINT32 offset, struct MemoryReadByte *mrb);
UINT8 galagacustcmdr(UINT32 offset, struct MemoryReadByte *mrb);
UINT8 galagadswr(UINT32 offset, struct MemoryReadByte *mrb);
void galaginten1(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);
void galaginten2(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);
void galaginten3(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);
void galagasharew(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);
void galagahaltw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);
void galagacustcmdw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);

void galagacustw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);
void dispgalagachar(int x,int y,int value,int col);
void dispgalagasprite(int x,int y,BYTE value,BYTE col,BYTE flip);

void galagapre(void);
void galagapost(void);

void galagbusy(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);

#endif
