#ifndef _GAL_SND_H_
#define _GAL_SND_H_

#define TOOTHSAW_LENGTH 16
#define TOOTHSAW_AMPLITUDE 64


typedef struct galsampshiftTAG
{
   int step;
   int shift;
} GALSAMPSHIFT;

#define BACK_FREQ    DEFAULT_FREQ+((15-lfofreq)*40)

void galreset(void);
void shootw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);
void deathw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);
void backlfo(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);
void lfoon(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);
void galvolw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);


void galsndinit(void);
void galpitchw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);
void galvolw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);
void galsndupd(void);
void galpartupdate(void);

void initzigzagsnd(void);
void zigzaglatchw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);
void zigzagdataw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);
void zigzagcontrolw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);

void checkmansndcmd(UINT16 offset, UINT8 value, struct z80PortWrite *zpw);

#endif
