#ifndef _GAL_VID_H_
#define _GAL_VID_H_

#define MAX_STARS 250


void waitint(void);
void initgal(void);
void cleargal(void);
void galint(void);
void romwrite(UINT32 offset,UINT8 value,struct MemoryWriteByte * mwb);
void romwrite2(UINT32 offset,UINT8 value,struct MemoryWriteByte * mwb);
UINT8 nopread(UINT32 offset, struct MemoryReadByte * mrb);
UINT8 galpxtitle(UINT32 offset, struct MemoryReadByte *mrb);

void updatescreen(void);
void dispchars(int charidx,int attridx);
void copyspr(pBYTE pIn,pBYTE pOut);
void drawbullets(void);
void drawstars(int scroll,int checkb);
void precalcstars(void);
void setpal(pBYTE pIn);
void drawsprites(int spridx,int sprcnt);
void stdsetpal(pBYTE pIn,int totcols);
void clearstars(void);
static inline void markgaldirty(int x,int y,int type);
void pacblupdatescreen(void);
void zigzagprotw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);
void zigupdatescreen(void);

void initcheckman(void);
void checkmanint(void);
UINT8 checkmanmir(UINT32 offset, struct MemoryReadByte * mrb);
void checkmandecode(void);
void updatecheckmanscr(void);
void drawnoflipsprites(int spridx,int nospr);
void unigfxbankw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);
void donothingmod(int *spr);
void unisprmod(int *spr);
void mcrstmod(int *spr);
void inituni(void);
UINT8 jumpbugprot(UINT32 offset, struct MemoryReadByte * mrb);
UINT8 jumpbugmirr(UINT32 offset, struct MemoryReadByte * mrb);
void jumpbugmirw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);
void initjumpbug(void);
void jumpbugupdatescreen(void);
void jumpbuggfxbankw(UINT32 offset, UINT8 value,struct MemoryWriteByte * mwb);
void jumpbugmod(int *spr);
void inithotshock(void);
void updatehotshockscreen(void);
void uniupdatescreen(void);
void ramwrite(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);
void ramwrite2(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);
UINT8 ramread(UINT32 offset, struct MemoryReadByte *mrb);
void bothwrite(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb);

UINT8 dingo_3000_r(UINT32 offset, struct MemoryReadByte * mrb);
UINT8 dingo_3035_r(UINT32 offset, struct MemoryReadByte * mrb);
UINT8 azurian_IN2_r(UINT32 offset, struct MemoryReadByte * mrb);
UINT8 azurian_IN1_r(UINT32 offset, struct MemoryReadByte * mrb);
#endif
