#ifndef _INV_MEM_H_
#define _INV_MEM_H_

struct MemoryWriteByte InvWrite[] =
{
   {0x0000,0x1fff,romwrite,NULL},
   {0x2400,0x3fff,invvidw,NULL},
   {0x4000,0x57ff,romwrite,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};


struct MemoryReadByte InvRead[] =
{
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};


struct z80PortRead InvReadPorts[] =
{
   {0x00,0x00,invportr0,NULL},
   {0x01,0x01,invportr1,NULL},
   {0x02,0x02,portdip1,NULL},
   {0x03,0x03,invportr3,NULL},
   {(UINT16)0xffff,     (UINT16)0xffff, NULL,NULL}
};

struct z80PortRead InvRvReadPorts[] =
{
   {0x00,0x00,invrvportr0,NULL},
   {0x01,0x01,invportr1,NULL},
   {0x02,0x02,portdip1,NULL},
   {0x03,0x03,invportr3,NULL},
   {(UINT16)0xffff,     (UINT16)0xffff, NULL,NULL}
};

struct z80PortWrite InvWritePorts[] =
{
   {0x00,0x00,invportw0,NULL},
   {0x02,0x02,invportw2,NULL},
   {0x03,0x03,invportw3,NULL},
   {0x04,0x04,invportw4,NULL},
   {0x05,0x05,invportw5,NULL},
   {0x06,0x06,invportw6,NULL},
   {(UINT16)0xffff,     (UINT16)0xffff, NULL,NULL}
};

#endif
