#ifndef _LADYBUG_MEM_H_
#define _LADYBUG_MEM_H_

struct MemoryWriteByte LadybugWrite[] =
{
   {0x0000,0x5fff,romwrite,NULL},
   {0x9000,0x9003,romwrite,NULL},
   {0xa000,0xa000,flipscreenw,NULL},
   {0xb000,0xbfff,SN76496_0_w,NULL},
   {0xc000,0xcfff,SN76496_1_w,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff,NULL,NULL}
};


struct MemoryReadByte LadybugRead[] =
{
   {0x8000,0x8fff,ladybugnop,NULL},
   {0x9001,0x9001,ladybugvb,NULL},
   {0x9002,0x9002,dip1,NULL},
   {0x9003,0x9003,dip2,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff,NULL,NULL}
};

#endif
