bits 32

extern _dirtyups
extern _DataSeg
extern _pScreen
extern _Sprites
extern _transcol
extern _markgendirty
extern _collookups
extern _FlipScreen
extern _Gfx
extern _FlipGfx

		section	.data	use32 flat class=data

times ($$-$) & 3 nop
SprFlipX        dd      0
SprFlipY        dd      0
XMove           dd      0
YMove           dd      0
GenSave         dd      0
PreCol          dd      0
SprBehind       dd      0

		section	.text use32 flat class=code


                global  _fastcopy
                global  fastcopy_

times ($$-$) & 3 nop

fastcopy_:
_fastcopy:
                push    ebp
                mov     ebp,esp

                pusha

                mov     eax,dword [_DataSeg]
                mov     edi,[ebp+8] ;dest
                mov     esi,[ebp+12] ;src
                mov     ecx,[ebp+16] ;len


                mov     es,ax
                mov     fs,ax

                cld
                rep
                movsd


                popa
                pop     ebp


		ret


                global  _sprblit
                global  sprblit_
;int x,int y,int value,int col,int flipx,int flipy)
times ($$-$) & 3 nop

sprblit_:
_sprblit:
                push    ebp
                mov     ebp,esp

                pusha
                mov     eax,[ebp+24]     ;flipx
                mov     dword [SprFlipX],eax
                mov     eax,[ebp+28]     ;flipy
                mov     dword [SprFlipY],eax

                mov     eax,[ebp+8]     ;x
                mov     ebx,[ebp+12]     ;y

                add     eax,32
                cmp     eax,dword 0
                jg      nendblit1
                jmp     endblit
nendblit1:

                add     ebx,32
                cmp     ebx,dword 0
                jg      nendblit2
                jmp     endblit
nendblit2:

                cmp     dword [_dirtyups], dword 0
                je      nodirty

                push    dword ebx
                push    dword eax

                call    _markgendirty

                pop     dword eax
                pop     dword ebx
nodirty:
                mov     ecx,[ebp+16]     ;val
                mov     edx,[ebp+20]     ;col

                mov     dword [XMove],dword 1
                mov     dword [YMove],dword 01f0h

                mov     esi,dword [_pScreen]
                add     esi,eax
                shl     ebx,9
                add     esi,ebx

                mov     edi,dword [_Sprites]
                shl     ecx,8
                add     edi,ecx
                shl     edx,17
                add     edi,edx

;flips
                cmp     dword [SprFlipY],dword 0
                je      noflipy
                add     esi,dword 01e00h
                mov     dword [YMove],dword -0210h
noflipy:

                cmp     dword [SprFlipX],dword 0
                je      noflipx

                add     esi,dword 0fh
                mov     dword [XMove],dword -1
                add     dword [YMove],dword 020h
noflipx:
                mov     edx,dword [XMove]
                mov     ebx,dword [YMove]



                mov     ah, byte [_transcol]
                mov     ecx,dword 16
heightlp:
                mov     al,byte [edi]
                cmp     al,ah
                je      noblit1
                mov     byte [esi],al
noblit1:
                add     esi,edx
                inc     edi

                mov     al,byte [edi]
                cmp     al,ah
                je      noblit2
                mov     byte [esi],al
noblit2:
                add     esi,edx
                inc     edi

                mov     al,byte [edi]
                cmp     al,ah
                je      noblit3
                mov     byte [esi],al
noblit3:
                add     esi,edx
                inc     edi

                mov     al,byte [edi]
                cmp     al,ah
                je      noblit4
                mov     byte [esi],al
noblit4:
                add     esi,edx
                inc     edi

                mov     al,byte [edi]
                cmp     al,ah
                je      noblit5
                mov     byte [esi],al
noblit5:
                add     esi,edx
                inc     edi

                mov     al,byte [edi]
                cmp     al,ah
                je      noblit6
                mov     byte [esi],al
noblit6:
                add     esi,edx
                inc     edi

                mov     al,byte [edi]
                cmp     al,ah
                je      noblit7
                mov     byte [esi],al
noblit7:
                add     esi,edx
                inc     edi

                mov     al,byte [edi]
                cmp     al,ah
                je      noblit8
                mov     byte [esi],al
noblit8:
                add     esi,edx
                inc     edi

                mov     al,byte [edi]
                cmp     al,ah
                je      noblit9
                mov     byte [esi],al
noblit9:
                add     esi,edx
                inc     edi

                mov     al,byte [edi]
                cmp     al,ah
                je      noblit10
                mov     byte [esi],al
noblit10:
                add     esi,edx
                inc     edi

                mov     al,byte [edi]
                cmp     al,ah
                je      noblit11
                mov     byte [esi],al
noblit11:
                add     esi,edx
                inc     edi

                mov     al,byte [edi]
                cmp     al,ah
                je      noblit12
                mov     byte [esi],al
noblit12:
                add     esi,edx
                inc     edi

                mov     al,byte [edi]
                cmp     al,ah
                je      noblit13
                mov     byte [esi],al
noblit13:
                add     esi,edx
                inc     edi

                mov     al,byte [edi]
                cmp     al,ah
                je      noblit14
                mov     byte [esi],al
noblit14:
                add     esi,edx
                inc     edi

                mov     al,byte [edi]
                cmp     al,ah
                je      noblit15
                mov     byte [esi],al
noblit15:
                add     esi,edx
                inc     edi

                mov     al,byte [edi]
                cmp     al,ah
                je      noblit16
                mov     byte [esi],al
noblit16:
                add     esi,edx
                inc     edi

                add     esi,ebx


                dec     ecx
                jnz     near heightlp

endblit:
                popa
                mov     esp,ebp
                pop     ebp

		ret
;                8     12     16        20      24         28       32       36           40
;void sprblitlk(int x,int y,int value,int col,int flipx,int flipy,int lkup,int colshift,int behind);
                global  _sprblitlk
                global  sprblitlk_

sprblitlk_:
_sprblitlk:
                push    ebp
                mov     ebp,esp

                pusha
                mov     eax,[ebp+24]     ;flipx
                mov     dword [SprFlipX],eax
                mov     eax,[ebp+28]     ;flipy
                mov     dword [SprFlipY],eax

                mov     eax,[ebp+40]    ;behind
                mov     dword [SprBehind],eax

                mov     eax,[ebp+8]     ;x
                mov     ebx,[ebp+12]     ;y

                add     eax,32
                cmp     eax,dword 0
                jg      lknendblit1
                jmp     lkendblit
lknendblit1:

                add     ebx,32
                cmp     ebx,dword 0
                jg      lknendblit2
                jmp     lkendblit
lknendblit2:

                mov     edx,[ebp+20]     ;col
                mov     ecx,[ebp+36]     ;colshift
                shl     edx,cl
                mov     dword [PreCol],edx
                mov     ecx,[ebp+16]     ;val


                mov     dword [GenSave],ebp
                mov     edx,[ebp+32] ; lkup
                shl     ecx,8
                mov     ebp,dword _collookups
                shl     edx,10
                add     ebp,edx

                mov     edi,dword [_Sprites]

                add     edi,ecx

                shl     ebx,9

                mov     dword [XMove],dword 1
                mov     dword [YMove],dword 01f0h

                mov     esi,dword [_pScreen]


;flips
                cmp     dword [SprFlipY],dword 0
                je      lknoflipy
                add     esi,dword 01e00h
                mov     dword [YMove],dword -0210h
lknoflipy:

                add     esi,eax

                cmp     dword [SprFlipX],dword 0
                je      lknoflipx

                add     esi,dword 0fh
                mov     dword [XMove],dword -1
                add     dword [YMove],dword 020h
lknoflipx:
                mov     edx,dword [XMove]

                add     esi,ebx

                mov     ebx,dword [PreCol]
                mov     ecx,dword 16

                cmp     dword [SprBehind],dword 0
                jne     blkheightlp
                jmp     nobehind
blkheightlp:

                cmp     byte [esi],byte 0
                jne     blknoblit1
                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      blknoblit1
                mov     byte [esi],al
blknoblit1:
                add     esi,edx
                inc     edi

                cmp     byte [esi],byte 0
                jne     blknoblit2

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      blknoblit2
                mov     byte [esi],al
blknoblit2:
                add     esi,edx
                inc     edi

                cmp     byte [esi],byte 0
                jne     blknoblit3

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      blknoblit3
                mov     byte [esi],al
blknoblit3:
                add     esi,edx
                inc     edi

                cmp     byte [esi],byte 0
                jne     blknoblit4

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      blknoblit4
                mov     byte [esi],al
blknoblit4:
                add     esi,edx
                inc     edi

                cmp     byte [esi],byte 0
                jne     blknoblit5

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      blknoblit5
                mov     byte [esi],al
blknoblit5:
                add     esi,edx
                inc     edi

                cmp     byte [esi],byte 0
                jne     blknoblit6

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      blknoblit6
                mov     byte [esi],al
blknoblit6:
                add     esi,edx
                inc     edi

                cmp     byte [esi],byte 0
                jne     blknoblit7

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      blknoblit7
                mov     byte [esi],al
blknoblit7:
                add     esi,edx
                inc     edi

                cmp     byte [esi],byte 0
                jne     blknoblit8

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      blknoblit8
                mov     byte [esi],al
blknoblit8:
                add     esi,edx
                inc     edi

                cmp     byte [esi],byte 0
                jne     blknoblit9

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      blknoblit9
                mov     byte [esi],al
blknoblit9:
                add     esi,edx
                inc     edi

                cmp     byte [esi],byte 0
                jne     blknoblit10

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      blknoblit10
                mov     byte [esi],al
blknoblit10:
                add     esi,edx
                inc     edi

                cmp     byte [esi],byte 0
                jne     blknoblit11

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      blknoblit11
                mov     byte [esi],al
blknoblit11:
                add     esi,edx
                inc     edi

                cmp     byte [esi],byte 0
                jne     blknoblit12

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      blknoblit12
                mov     byte [esi],al
blknoblit12:
                add     esi,edx
                inc     edi

                cmp     byte [esi],byte 0
                jne     blknoblit13

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      blknoblit13
                mov     byte [esi],al
blknoblit13:
                add     esi,edx
                inc     edi

                cmp     byte [esi],byte 0
                jne     blknoblit14

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      blknoblit14
                mov     byte [esi],al
blknoblit14:
                add     esi,edx
                inc     edi

                cmp     byte [esi],byte 0
                jne     blknoblit15

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      blknoblit15
                mov     byte [esi],al
blknoblit15:
                add     esi,edx
                inc     edi

                cmp     byte [esi],byte 0
                jne     blknoblit16

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      blknoblit16
                mov     byte [esi],al
blknoblit16:
                add     esi,edx
                inc     edi


                add     esi,dword [YMove]

                dec     ecx
                jnz     near blkheightlp

                jmp     lkendblit
nobehind:
lkheightlp:

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      lknoblit1
                mov     byte [esi],al
lknoblit1:
                add     esi,edx
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      lknoblit2
                mov     byte [esi],al
lknoblit2:
                add     esi,edx
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      lknoblit3
                mov     byte [esi],al
lknoblit3:
                add     esi,edx
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      lknoblit4
                mov     byte [esi],al
lknoblit4:
                add     esi,edx
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      lknoblit5
                mov     byte [esi],al
lknoblit5:
                add     esi,edx
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      lknoblit6
                mov     byte [esi],al
lknoblit6:
                add     esi,edx
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      lknoblit7
                mov     byte [esi],al
lknoblit7:
                add     esi,edx
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      lknoblit8
                mov     byte [esi],al
lknoblit8:
                add     esi,edx
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      lknoblit9
                mov     byte [esi],al
lknoblit9:
                add     esi,edx
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      lknoblit10
                mov     byte [esi],al
lknoblit10:
                add     esi,edx
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      lknoblit11
                mov     byte [esi],al
lknoblit11:
                add     esi,edx
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      lknoblit12
                mov     byte [esi],al
lknoblit12:
                add     esi,edx
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      lknoblit13
                mov     byte [esi],al
lknoblit13:
                add     esi,edx
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      lknoblit14
                mov     byte [esi],al
lknoblit14:
                add     esi,edx
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      lknoblit15
                mov     byte [esi],al
lknoblit15:
                add     esi,edx
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,byte 0
                je      lknoblit16
                mov     byte [esi],al
lknoblit16:
                add     esi,edx
                inc     edi


                add     esi,dword [YMove]

                dec     ecx
                jnz     near lkheightlp

lkendblit:
                popa
                mov     ebp,dword [GenSave]
                mov     esp,ebp
                pop     ebp

		ret
;                  8     12    16         20     24       28
;void charblitlk(int x,int y,int value,int col,int lkup,int colshift);
                global  _charblitlk
                global  charblitlk_

charblitlk_:
_charblitlk:
                push    ebp
                mov     ebp,esp

                pusha

                mov     eax,[ebp+8]     ;x
                mov     ebx,[ebp+12]     ;y

                add     eax,32
                cmp     eax,dword 0
                jg      clknendblit1
                jmp     clkendblit
clknendblit1:

                add     ebx,32
                cmp     ebx,dword 0
                jg      clknendblit2
                jmp     clkendblit
clknendblit2:

                mov     edx,[ebp+20]     ;col
                mov     ecx,[ebp+28]     ;colshift
                shl     edx,cl
                mov     dword [PreCol],edx
                mov     ecx,[ebp+16]     ;val


                mov     dword [GenSave],ebp
                mov     edx,[ebp+24] ; lkup
                shl     ecx,6
                mov     ebp,dword _collookups
                shl     edx,10
                add     ebp,edx

                cmp     dword [_FlipScreen],dword 0
                je      clknoflip
                mov     edi,dword [_FlipGfx]
                jmp     pclknoflip
clknoflip:
                mov     edi,dword [_Gfx]
pclknoflip:

                add     edi,ecx

                shl     ebx,9


                mov     esi,dword [_pScreen]



                add     esi,ebx

                mov     ebx,dword [PreCol]
                mov     ecx,dword 8
                add     esi,eax

clkheightlp:

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                mov     byte [esi],al
                inc     esi
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                mov     byte [esi],al
                inc     esi
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                mov     byte [esi],al
                inc     esi
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                mov     byte [esi],al
                inc     esi
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                mov     byte [esi],al
                inc     esi
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                mov     byte [esi],al
                inc     esi
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                mov     byte [esi],al
                inc     esi
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                mov     byte [esi],al
                inc     edi

                add     esi,(512-7)

                dec     ecx
                jnz     near clkheightlp

clkendblit:
                popa
                mov     ebp,dword [GenSave]
                mov     esp,ebp
                pop     ebp

		ret
;                     8          12    16    20        24      28       32
;void charblitlktmp(pBYTE pDest,int x,int y,int value,int col,int lkup,int colshift);
                global  _charblitlktmp
                global  charblitlktmp_

charblitlktmp_:
_charblitlktmp:
                push    ebp
                mov     ebp,esp

                pusha

                mov     eax,[ebp+12]     ;x
                mov     ebx,[ebp+16]     ;y

                cmp     eax,dword 0
                jge     tclknendblit1
                jmp     tclkendblit
tclknendblit1:

                cmp     ebx,dword 0
                jge     tclknendblit2
                jmp     tclkendblit
tclknendblit2:

                mov     edx,[ebp+24]     ;col
                mov     ecx,[ebp+32]     ;colshift
                shl     edx,cl
                mov     dword [PreCol],edx
                mov     ecx,[ebp+20]     ;val

                mov     esi,dword [ebp+8]       ;destination

                mov     dword [GenSave],ebp
                mov     edx,[ebp+28] ; lkup
                shl     ecx,6
                mov     ebp,dword _collookups
                shl     edx,10
                shl     ebx,9


                cmp     dword [_FlipScreen],dword 0
                je      tclknoflip
                mov     edi,dword [_FlipGfx]
                jmp     tpclknoflip
tclknoflip:
                mov     edi,dword [_Gfx]
tpclknoflip:

                add     ebp,edx

                add     edi,ecx
                add     esi,ebx


                mov     ebx,dword [PreCol]
                mov     ecx,dword 8
                add     esi,eax

tclkheightlp:

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                mov     byte [esi],al
                inc     esi
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                mov     byte [esi],al
                inc     esi
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                mov     byte [esi],al
                inc     esi
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                mov     byte [esi],al
                inc     esi
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                mov     byte [esi],al
                inc     esi
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                mov     byte [esi],al
                inc     esi
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                mov     byte [esi],al
                inc     esi
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]
                or      eax,ebx
                mov     al,byte [ebp+eax]
                mov     byte [esi],al
                inc     edi

                add     esi,(512-7)

                dec     ecx
                jnz     near tclkheightlp

tclkendblit:
                popa
                mov     ebp,dword [GenSave]
                mov     esp,ebp
                pop     ebp

		ret

;                         8       12    16      20        24      28
;void charblitlktmptrans(int x,int y,int value,int col,int lkup,int colshift);
                global  _charblitlktrans
                global  charblitlktrans_

charblitlktrans_:
_charblitlktrans:
                push    ebp
                mov     ebp,esp

                pusha

                mov     eax,[ebp+8]     ;x
                mov     ebx,[ebp+12]     ;y
                add     eax,dword 32

                cmp     eax,dword 0
                jge     ttclknendblit1
                jmp     ttclkendblit
ttclknendblit1:

                add     ebx,dword 32
                cmp     ebx,dword 0
                jge     ttclknendblit2
                jmp     ttclkendblit
ttclknendblit2:

                mov     edx,[ebp+20]     ;col
                mov     ecx,[ebp+28]     ;colshift
                shl     edx,cl
                mov     dword [PreCol],edx
                mov     ecx,[ebp+16]     ;val

                mov     esi,dword [_pScreen]       ;destination

                mov     dword [GenSave],ebp
                mov     edx,[ebp+24] ; lkup
                shl     ecx,6
                mov     ebp,dword _collookups
                shl     edx,10
                shl     ebx,9


                cmp     dword [_FlipScreen],dword 0
                je      ttclknoflip
                mov     edi,dword [_FlipGfx]
                jmp     ttpclknoflip
ttclknoflip:
                mov     edi,dword [_Gfx]
ttpclknoflip:

                add     ebp,edx

                add     edi,ecx
                add     esi,ebx


                mov     ebx,dword [PreCol]
                mov     ecx,dword 8
                add     esi,eax
                mov     dl, byte [_transcol]

ttclkheightlp:

                xor     eax,eax
                mov     al,byte [edi]

                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,dl
                je      ttnoblit1

                mov     byte [esi],al
ttnoblit1:
                inc     esi
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]

                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,dl
                je      ttnoblit2

                mov     byte [esi],al
ttnoblit2:
                inc     esi
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]

                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,dl
                je      ttnoblit3

                mov     byte [esi],al
ttnoblit3:
                inc     esi
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]

                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,dl
                je      ttnoblit4

                mov     byte [esi],al
ttnoblit4:
                inc     esi
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]

                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,dl
                je      ttnoblit5

                mov     byte [esi],al
ttnoblit5:
                inc     esi
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]

                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,dl
                je      ttnoblit6

                mov     byte [esi],al
ttnoblit6:
                inc     esi
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]

                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,dl
                je      ttnoblit7

                mov     byte [esi],al
ttnoblit7:
                inc     esi
                inc     edi

                xor     eax,eax
                mov     al,byte [edi]

                or      eax,ebx
                mov     al,byte [ebp+eax]
                cmp     al,dl
                je      ttnoblit8
                mov     byte [esi],al
ttnoblit8:
                inc     edi

                add     esi,(512-7)

                dec     ecx
                jnz     near ttclkheightlp

ttclkendblit:
                popa
                mov     ebp,dword [GenSave]
                mov     esp,ebp
                pop     ebp

		ret


                end
