.text
//function to blit 'galaxian style' char
//.x pixel based offset per row
//.blanks or spaces not blitted
.globl _galdispchars
   .align 4
_galdispchars:
  pusha
//save es and set our selector and base pointers
  pushw %es
  movw  _DataSeg,%es

  movl  _pCharMem,%esi
  movl  _pAttrMem,%edi
  xorl  %eax,%eax
  movl  _startchar,%edx
  cmpl  $0,_realorient
  je    rotchar
htlp:
  xorl  %ecx,%ecx
wdthlp:
  movl  %edx,%ebx
  shll  $5,%ebx
  addl  %esi,%ebx
  addl  %ecx,%ebx
  movb  (%ebx),%al

  pushl %eax
  pushl %ebx
  pushl %ecx
  pushl %edx
  pushl %esi
  pushl %edi

//dirty updates
  leal  _pacdirty,%esi
//x pos
  movl  %ecx,%ebx
  shll  $2,%ebx
  addl  %ebx,%esi

//y pos
  movl  %edx,%ebx
  shll  $7,%ebx

  addl  %ebx,%esi
//get offset
  movl  %ecx,%ebx
  shll  $1,%ebx
  addl  %edi,%ebx
//use edx as temp storage
  pushl %edx
//offset + colour
  xorl  %edx,%edx
  movw  (%ebx),%dx
  shll  $8,%edx
  movl  %edx,%ebx
  popl  %edx
//char code in bottom 8 bits
  movb  %al,%bl
//see if it's dirty
  cmpl  %ebx,(%esi)
  je    nodirt
//store char+offset+colour
  movl  %ebx,(%esi)


//sprite code in al
//x in bx
  movl  %ecx,%ebx
  shll  $3,%ebx
  cmpb  $1,_FlipScreen
  jne   noflip1
  notl  %ebx
  andl  $0xff,%ebx

  movl  _FlipGfx,%esi
  shll  $3,%edx
//y in dx
  notl  %edx
  andl  $0xff,%edx
  shll  $1,%ecx
  addl  %edi,%ecx
  addb  (%ecx),%dl
  jmp   pnoflip1
noflip1:
  movl  _Gfx,%esi
  shll  $3,%edx
  shll  $1,%ecx
  addl  %edi,%ecx
  subb  (%ecx),%dl
pnoflip1:

//col in cx
  incl  %ecx
  movl  (%ecx),%edi
  andl  $7,%edi
  movl  %edi,%ecx
  movl  _pScreen,%edi


//move pointer to source
  shll  $16,%ecx
  addl  %ecx,%esi
  shll  $6,%eax
  addl  %eax,%esi
//skip clip boundary
  cmpb  $1,_FlipScreen
  jne   noflip2
  addl  $25,%ebx
  addl  $25,%edx
  jmp   pnoflip2
noflip2:
  addl  $32,%ebx
  addl  $32,%edx
pnoflip2:
//move pointer to destination
  addl  %ebx,%edi
  shll  $9,%edx
  addl  %edx,%edi


  cld
  movl  $2,%edx
  movl  $504,%ebx
  movl  %edx,%ecx
//do the actual blit
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl

nodirt:
  popl  %edi
  popl  %esi
  popl  %edx
  popl  %ecx
  popl  %ebx
  popl  %eax


  incl  %ecx
  cmpl  $32,%ecx
  jne   wdthlp

  incl  %edx
  cmpl  _maxchar,%edx
  jne   htlp

  jmp   aldone
rotchar:
htlp2:
  xorl  %ecx,%ecx
wdthlp2:
  movl  %edx,%ebx
  shll  $5,%ebx
  addl  %esi,%ebx
  addl  %ecx,%ebx

  movb  (%ebx),%al
  pushl %eax
  pushl %ebx
  pushl %ecx
  pushl %edx
  pushl %esi
  pushl %edi

//dirty updates
  leal  _pacdirty,%esi
//x pos
  movl  %ecx,%ebx
  shll  $2,%ebx
  addl  %ebx,%esi

//y pos
  movl  %edx,%ebx
  shll  $7,%ebx

  addl  %ebx,%esi
//get offset
  movl  %ecx,%ebx
  shll  $1,%ebx
  addl  %edi,%ebx
//use edx as temp storage
  pushl %edx
//offset + colour
  xorl  %edx,%edx
  movw  (%ebx),%dx
  shll  $8,%edx
  movl  %edx,%ebx
  popl  %edx
//char code in bottom 8 bits
  movb  %al,%bl
  cmpl  %ebx,(%esi)
  je    nodirt2
//store char+offset+colour
  movl  %ebx,(%esi)


//sprite code in al
//x in bx
  movl  %ecx,%ebx

  shll  $3,%ebx
  cmpb  $1,_FlipScreen
  jne   rotnoflip1
  notl  %ebx
  andl  $0xff,%ebx
  shll  $3,%edx
  movl  _FlipGfx,%esi
  jmp   protnoflip1
rotnoflip1:
  movl  _Gfx,%esi
//y in dx
  shll  $3,%edx
protnoflip1:

  shll  $1,%ecx
  addl  %edi,%ecx
  subb  (%ecx),%dl
//col in cx
  incl  %ecx
  movl  (%ecx),%edi
  andl  $7,%edi
  movl  %edi,%ecx
//blit char
  movl  _pScreen,%edi
//move pointer to source
  shll  $16,%ecx
  addl  %ecx,%esi
  shll  $6,%eax
  addl  %eax,%esi
  cmpb  $1,_FlipScreen
  jne   rotnoflip2
//skip clip boundary
  addl  $25,%ebx
  addl  $39,%edx
  jmp   protnoflip2
rotnoflip2:
//skip clip boundary
  addl  $32,%ebx
//move pointer to destination
  notl  %edx
  andl  $0xff,%edx
  addl  $32,%edx
protnoflip2:
  addl  %edx,%edi

  shll  $9,%ebx
  addl  %ebx,%edi

  cld
  movl  $2,%edx
  movl  $504,%ebx
  movl  %edx,%ecx

  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl

nodirt2:
  popl  %edi
  popl  %esi
  popl  %edx
  popl  %ecx
  popl  %ebx
  popl  %eax


  incl  %ecx
  cmpl  $32,%ecx
  jne   wdthlp2

  incl  %edx
  cmpl  _maxchar,%edx
  jne   htlp2


aldone:
  popw  %es

  popa
  ret



//function to blit 'moon cresta style' char
//identical to galaxian, but with gfx extension check
//.x pixel based offset per row
//.blanks or spaces not blitted
.globl _moondispchars
   .align 4
_moondispchars:
  pusha
//save es and set our selector and base pointers
  pushw %es
  movw  _DataSeg,%es

  movl  _pCharMem,%esi
  movl  _pAttrMem,%edi
  xorl  %eax,%eax
  xorl  %edx,%edx
  cmpl  $0,_realorient
  je    mrotchar
mhtlp:
  xorl  %ecx,%ecx
mwdthlp:
  movl  %edx,%ebx
  shll  $5,%ebx
  addl  %esi,%ebx
  addl  %ecx,%ebx
  movb  (%ebx),%al
  cmpb  _blnkchar,%al
  je    mpnoblnk
  pushl %eax
  pushl %ebx
  pushl %ecx
  pushl %edx
  pushl %esi
  pushl %edi

//sprite code in al
//check for extended chars (mooncresta)
  testl $4,_gfxext
  jz    mnoext
  movl  %eax,%ebx
  andl  $0xc0,%ebx
  cmpl  $0x80,%ebx
  jne   mnoext
  andl  $0x3f,%eax
  movl  _gfxext,%ebx
  shll  $6,%ebx
  orl   %ebx,%eax
mnoext:

//x in bx
  movl  %ecx,%ebx
  shll  $3,%ebx
  cmpb  $1,_FlipScreen
  jne   mnoflip1
  notl  %ebx
  andl  $0xff,%ebx

  movl  _FlipGfx,%esi
  shll  $3,%edx
//y in dx
  notl  %edx
  andl  $0xff,%edx
  shll  $1,%ecx
  addl  %edi,%ecx
  addb  (%ecx),%dl
  jmp   mpnoflip1
mnoflip1:
  movl  _Gfx,%esi
  shll  $3,%edx
  shll  $1,%ecx
  addl  %edi,%ecx
  subb  (%ecx),%dl
mpnoflip1:

//col in cx
  incl  %ecx
  movl  (%ecx),%edi
  andl  $7,%edi
  movl  %edi,%ecx
  movl  _pScreen,%edi


//move pointer to source
  shll  $16,%ecx
  addl  %ecx,%esi
  shll  $6,%eax
  addl  %eax,%esi
//skip clip boundary
  cmpb  $1,_FlipScreen
  jne   mnoflip2
  addl  $25,%ebx
  addl  $25,%edx
  jmp   mpnoflip2
mnoflip2:
  addl  $32,%ebx
  addl  $32,%edx
mpnoflip2:
//move pointer to destination
  addl  %ebx,%edi
  shll  $9,%edx
  addl  %edx,%edi


  cld

  movl  $2,%edx
  movl  $504,%ebx
  movl  %edx,%ecx

  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl


  popl  %edi
  popl  %esi
  popl  %edx
  popl  %ecx
  popl  %ebx
  popl  %eax

mpnoblnk:
  incl  %ecx
  cmpl  $32,%ecx
  jne   mwdthlp

  incl  %edx
  cmpl  $32,%edx
  jne   mhtlp

  jmp   maldone
mrotchar:
mhtlp2:
  xorl  %ecx,%ecx
mwdthlp2:
  movl  %edx,%ebx
  shll  $5,%ebx
  addl  %esi,%ebx
  addl  %ecx,%ebx

  movb  (%ebx),%al
  cmpb  _blnkchar,%al
  je    mpnoblnk2
  pushl %eax
  pushl %ebx
  pushl %ecx
  pushl %edx
  pushl %esi
  pushl %edi
//sprite code in al
//check for extended chars
  testl $4,_gfxext
  jz    mnoext2
  movl  %eax,%ebx
  andl  $0xc0,%ebx
  cmpl  $0x80,%ebx
  jne   mnoext2
  andl  $0x3f,%eax
  movl  _gfxext,%ebx
  shll  $6,%ebx
  orl   %ebx,%eax
mnoext2:

//sprite code in al
//x in bx
  movl  %ecx,%ebx
  shll  $3,%ebx
  cmpb  $1,_FlipScreen
  jne   mrotnoflip1
  notl  %ebx
  andl  $0xff,%ebx
  shll  $3,%edx
  movl  _FlipGfx,%esi
  jmp   mprotnoflip1
mrotnoflip1:
  movl  _Gfx,%esi
//y in dx
  shll  $3,%edx
mprotnoflip1:

  shll  $1,%ecx
  addl  %edi,%ecx
  subb  (%ecx),%dl
//col in cx
  incl  %ecx
  movl  (%ecx),%edi
  andl  $7,%edi
  movl  %edi,%ecx
//blit char
  movl  _pScreen,%edi
//move pointer to source
  shll  $16,%ecx
  addl  %ecx,%esi
  shll  $6,%eax
  addl  %eax,%esi
  cmpb  $1,_FlipScreen
  jne   mrotnoflip2
//skip clip boundary
  addl  $25,%ebx
  addl  $39,%edx
  jmp   mprotnoflip2
mrotnoflip2:
//skip clip boundary
  addl  $32,%ebx
//move pointer to destination
  notl  %edx
  andl  $0xff,%edx
  addl  $32,%edx
mprotnoflip2:
  addl  %edx,%edi

  shll  $9,%ebx
  addl  %ebx,%edi

  cld
  movl  $2,%edx
  movl  $504,%ebx
  movl  %edx,%ecx

  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl


  popl  %edi
  popl  %esi
  popl  %edx
  popl  %ecx
  popl  %ebx
  popl  %eax

mpnoblnk2:
  incl  %ecx
  cmpl  $32,%ecx
  jne   mwdthlp2

  incl  %edx
  cmpl  $32,%edx
  jne   mhtlp2


maldone:
  popw  %es

  popa
  ret


//function to blit 'scramble style' char
//.x pixel based offset per row
//.blanks or spaces not blitted
//.chars blitted with transparency (if background is on)
.globl _scramdispchars
   .align 4
_scramdispchars:
  pusha
//save es and set our selector and base pointers
  pushw %es
  movw  _DataSeg,%es

  movl  _pCharMem,%esi
  movl  _pAttrMem,%edi
  xorl  %eax,%eax
  movl  $0,%edx
  cmpl  $0,_realorient
  je    rotcharscram
htlpscram:
  movl  $0,%ecx
wdthlpscram:
  movl  %edx,%ebx
  shll  $5,%ebx
  addl  %esi,%ebx
  addl  %ecx,%ebx
  movb  (%ebx),%al
  cmpb  _blnkchar,%al
  je    pnoblnkscram
  pushl %eax
  pushl %ebx
  pushl %ecx
  pushl %edx
  pushl %esi
  pushl %edi

//x in bx
  movl  %ecx,%ebx
  shll  $3,%ebx
  cmpb  $1,_FlipScreen
  jne   snoflip1
  notl  %ebx
  andl  $0xff,%ebx

  movl  _FlipGfx,%esi
  shll  $3,%edx
//y in dx
  notl  %edx
  andl  $0xff,%edx
  shll  $1,%ecx
  addl  %edi,%ecx
  addb  (%ecx),%dl
  jmp   spnoflip1
snoflip1:
  movl  _Gfx,%esi
  shll  $3,%edx
  shll  $1,%ecx
  addl  %edi,%ecx
  subb  (%ecx),%dl
spnoflip1:

//col in cx
  incl  %ecx
  movl  (%ecx),%edi
  andl  $7,%edi
  movl  %edi,%ecx
  movl  _pScreen,%edi


//move pointer to source
  shll  $16,%ecx
  addl  %ecx,%esi
  shll  $6,%eax
  addl  %eax,%esi
//skip clip boundary
  cmpb  $1,_FlipScreen
  jne   snoflip2
  addl  $25,%ebx
  addl  $25,%edx
  jmp   spnoflip2
snoflip2:
  addl  $32,%ebx
  addl  $32,%edx
spnoflip2:
//move pointer to destination
  addl  %ebx,%edi
  shll  $9,%edx
  addl  %edx,%edi


  cld
  movl  $2,%edx
  movl  $504,%ebx


  movl  %edx,%ecx

  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl

  popl  %edi
  popl  %esi
  popl  %edx
  popl  %ecx
  popl  %ebx
  popl  %eax

pnoblnkscram:
  incl  %ecx
  cmpl  $32,%ecx
  jne   wdthlpscram

  incl  %edx
  cmpl  $32,%edx
  jne   htlpscram

  jmp   aldonescram
rotcharscram:
htlp2scram:
  movl  $0,%ecx
wdthlp2scram:
  movl  %edx,%ebx
  shll  $5,%ebx
  addl  %esi,%ebx
  addl  %ecx,%ebx

  movb  (%ebx),%al
  cmpb  _blnkchar,%al
  je    pnoblnk2scram
  pushl %eax
  pushl %ebx
  pushl %ecx
  pushl %edx
  pushl %esi
  pushl %edi


//x in bx
  movl  %ecx,%ebx
  shll  $3,%ebx
  cmpb  $1,_FlipScreen
  jne   srotnoflip1
  notl  %ebx
  andl  $0xff,%ebx
  shll  $3,%edx
  movl  _FlipGfx,%esi
  jmp   sprotnoflip1
srotnoflip1:
  movl  _Gfx,%esi
//y in dx
  shll  $3,%edx
sprotnoflip1:

  shll  $1,%ecx
  addl  %edi,%ecx
  subb  (%ecx),%dl
//col in cx
  incl  %ecx
  movl  (%ecx),%edi
  andl  $7,%edi
  movl  %edi,%ecx
//blit char
  movl  _pScreen,%edi
//move pointer to source
  shll  $16,%ecx
  addl  %ecx,%esi
  shll  $6,%eax
  addl  %eax,%esi
  cmpb  $1,_FlipScreen
  jne   srotnoflip2
//skip clip boundary
  addl  $25,%ebx
  addl  $39,%edx
  jmp   sprotnoflip2
srotnoflip2:
//skip clip boundary
  addl  $32,%ebx
//move pointer to destination
  notl  %edx
  andl  $0xff,%edx
  addl  $32,%edx
sprotnoflip2:
  addl  %edx,%edi

  shll  $9,%ebx
  addl  %ebx,%edi

  cld

  movl  $2,%edx
  movl  $504,%ebx

  movl  %edx,%ecx

  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl



  popl  %edi
  popl  %esi
  popl  %edx
  popl  %ecx
  popl  %ebx
  popl  %eax

pnoblnk2scram:
  incl  %ecx
  cmpl  $32,%ecx
  jne   wdthlp2scram

  incl  %edx
  cmpl  $32,%edx
  jne   htlp2scram


aldonescram:
  popw  %es
  popa
  ret

//'amidar' chars
//.no x pixel based offset per row
//.blanks or spaces blitted
//.dirty updates
.globl _amddispchars
   .align 4
_amddispchars:
  pusha
//save es and set our selector and base pointers
  pushw %es
  movw  _DataSeg,%es

  movl  _pCharMem,%esi
  movl  _pAttrMem,%edi

  movl  $2,%edx
  cmpl  $0,_realorient
  je    rotcharamd

htlpamd:
  movl  $0,%ecx
wdthlpamd:
  movl  %edx,%ebx
  shll  $5,%ebx
  addl  %esi,%ebx
  addl  %ecx,%ebx


  xorl  %eax,%eax
  movb  (%ebx),%al

  pushl %eax
  pushl %ebx
  pushl %ecx
  pushl %edx
  pushl %esi
  pushl %edi
  leal  _pacdirty,%esi


///
//x in bx
  movl  %ecx,%ebx
//setup x dirty
  shll  $2,%ebx
  addl  %ebx,%esi
  shll  $1,%ebx
//y in dx
  shll  $3,%edx
  shll  $1,%ecx
  addl  %edi,%ecx

  pushl %edx


//setup y dirty
  shll  $4,%edx
  addl  %edx,%esi
//col in cx
  incl  %ecx
  movl  (%ecx),%edx
  andl  $7,%edx
  movl  %edx,%ecx

//check dirty
  movb  %al,%dl
  movb  %cl,%dh

  cmpw  %dx,(%esi)
  jne   doamdblit


  popl  %edx
  jmp   noamdblit
doamdblit:
  movw  %dx,(%esi)

  popl  %edx

//blit char
  movl  _pScreen,%edi
  cmpb  $1,_FlipScreen
  jne   anoflip2
  movl  _FlipGfx,%esi

  notl  %ebx
  andl  $0xff,%ebx
  subl  $7,%ebx
  notl  %edx
  andl  $0xff,%edx
  subl  $4,%edx


  jmp   apnoflip2
anoflip2:
  movl  _Gfx,%esi
apnoflip2:
//move pointer to source
  shll  $16,%ecx
  addl  %ecx,%esi
  shll  $6,%eax
  addl  %eax,%esi
//skip clip boundary
  pushl %edx
  addl  $32,%ebx
  addl  $32,%edx
//move pointer to destination
  addl  %ebx,%edi
  shll  $9,%edx
  addl  %edx,%edi


//update dirty blit page info
  popl  %edx
  pushl %edx
  cmpl  _dyoff,%edx
  jl    dpoff1
  subl  _dyoff,%edx
  leal  _dpage,%ebx
amdplp1:
  cmpl  _dsize,%edx
  jl    amddpdone1
  subl  _dsize,%edx
  addl  $4,%ebx
  jmp   amdplp1
amddpdone1:
  movl  (%ebx),%edx
  movl  $1,(%edx)
dpoff1:
  popl  %edx
  addl  $7,%edx
  cmpl  _dyoff,%edx
  jl    dpoff2
  subl  _dyoff,%edx
  leal  _dpage,%ebx
amdplp2:
  cmpl  _dsize,%edx
  jl    amddpdone2
  subl  _dsize,%edx
  addl  $4,%ebx
  jmp   amdplp2
amddpdone2:
  movl  (%ebx),%edx
  movl  $1,(%edx)
dpoff2:


  movl  $504,%ebx
  movl  %edx,%ecx

  movsl
  movsl
  addl  %ebx,%edi
  movsl
  movsl
  addl  %ebx,%edi

  movsl
  movsl
  addl  %ebx,%edi

  movsl
  movsl
  addl  %ebx,%edi

  movsl
  movsl
  addl  %ebx,%edi

  movsl
  movsl
  addl  %ebx,%edi

  movsl
  movsl
  addl  %ebx,%edi

  movsl
  movsl


noamdblit:
  popl  %edi
  popl  %esi
  popl  %edx
  popl  %ecx
  popl  %ebx
  popl  %eax

pnoblnkamd:
  incl  %ecx
  cmpl  $32,%ecx
  jne   wdthlpamd

  incl  %edx
  cmpl  $30,%edx
  jne   htlpamd

  jmp   aldoneamd
rotcharamd:
htlp2amd:
  movl  $0,%ecx
wdthlp2amd:
  movl  %edx,%ebx
  shll  $5,%ebx
  addl  %esi,%ebx
  addl  %ecx,%ebx

  xorl  %eax,%eax
  movb  (%ebx),%al

  pushl %eax
  pushl %ebx
  pushl %ecx
  pushl %edx
  pushl %esi
  pushl %edi
  leal  _pacdirty,%esi

//sprite code in al
//x in bx
  movl  %ecx,%ebx
  shll  $7,%ebx
//setup dirty y
  addl  %ebx,%esi
  shrl  $4,%ebx
//y in dx
  pushl %edx
//setup dirty x
  notl  %edx
  andl  $31,%edx
  shll  $2,%edx
  addl  %edx,%esi
  popl  %edx

  shll  $3,%edx

  shll  $1,%ecx
  addl  %edi,%ecx
//col in cx
  pushl %edx
  incl  %ecx
  movl  (%ecx),%edx
  andl  $7,%edx
  movl  %edx,%ecx
//check dirty
  movb  %al,%dl
  movb  %cl,%dh
  cmpw  %dx,(%esi)
  jne   doamdblit2
  popl  %edx
  jmp   noamdblit2

doamdblit2:
  movw  %dx,(%esi)
  popl  %edx

//blit char
  movl  _pScreen,%edi
  cmpb  $1,_FlipScreen
  jne   anoflip3
  movl  _FlipGfx,%esi
  notl  %ebx
  andl  $0xff,%ebx
  subl  $7,%ebx
  addl  $4,%edx
  jmp   apnoflip3
anoflip3:
  movl  _Gfx,%esi
  notl  %edx
  andl  $0xff,%edx
apnoflip3:

//move pointer to source
  shll  $16,%ecx
  addl  %ecx,%esi
  shll  $6,%eax
  addl  %eax,%esi

//skip clip boundary
  push  %ebx
  addl  $32,%ebx
//move pointer to destination
  addl  $32,%edx
  addl  %edx,%edi

  shll  $9,%ebx
  addl  %ebx,%edi

//update dirty blit page info
  popl  %edx
  leal  _dpage,%ebx
rotamdplp:
  cmpl  _dsize,%edx
  jl    rotamddpdone
  subl  _dsize,%edx
  addl  $4,%ebx
  jmp   rotamdplp
rotamddpdone:
  movl  (%ebx),%edx
  movl  $1,(%edx)


  cld
  movl  $2,%edx
  movl  $504,%ebx
  movl  %edx,%ecx

  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl

noamdblit2:
  popl  %edi
  popl  %esi
  popl  %edx
  popl  %ecx
  popl  %ebx
  popl  %eax

pnoblnk2amd:
  incl  %ecx
  cmpl  $32,%ecx
  jne   wdthlp2amd

  incl  %edx
  cmpl  $30,%edx
  jne   htlp2amd


aldoneamd:
  popw  %es
  popa
  ret

//function to blit jump bug char
//.x pixel based offset per row
//.blanks or spaces not blitted
//.specific character extension
.globl _jbugdispchars
   .align 4
_jbugdispchars:
  pusha
//save es and set our selector and base pointers
  pushw %es
  movw  _DataSeg,%es

  movl  _pCharMem,%esi
  movl  _pAttrMem,%edi
  xorl  %eax,%eax
  movl  _startchar,%edx
  cmpl  $0,_realorient
  je    jbrotchar
jbhtlp:
  xorl  %ecx,%ecx
jbwdthlp:
  movl  %edx,%ebx
  shll  $5,%ebx
  addl  %esi,%ebx
  addl  %ecx,%ebx
  movb  (%ebx),%al

  pushl %eax
  pushl %ebx
  pushl %ecx
  pushl %edx
  pushl %esi
  pushl %edi

//dirty updates
  leal  _pacdirty,%esi
//x pos
  movl  %ecx,%ebx
  shll  $2,%ebx
  addl  %ebx,%esi

//y pos
  movl  %edx,%ebx
  shll  $7,%ebx

  addl  %ebx,%esi
//get offset
  movl  %ecx,%ebx
  shll  $1,%ebx
  addl  %edi,%ebx
//use edx as temp storage
  pushl %edx
//offset + colour
  xorl  %edx,%edx
  movw  (%ebx),%dx
  shll  $8,%edx
  movl  %edx,%ebx
  popl  %edx
//char code in bottom 8 bits
  movb  %al,%bl
//see if it's dirty
  cmpl  %ebx,(%esi)
  je    jbnodirt
//store char+offset+colour
  movl  %ebx,(%esi)


//sprite code in al
//check for extended chars (jumpbug)
  cmpl  $0,_jbugbank2
  je    jbnoext
  movl  %eax,%ebx
  andl  $0xc0,%ebx
  cmpl  $0x80,%ebx
  jne   jbnoext
  addl  _jbugmodchar,%eax
jbnoext:
//x in bx
  movl  %ecx,%ebx
  shll  $3,%ebx
  cmpb  $1,_FlipScreen
  jne   jbnoflip1
  notl  %ebx
  andl  $0xff,%ebx

  movl  _FlipGfx,%esi
  shll  $3,%edx
//y in dx
  notl  %edx
  andl  $0xff,%edx
  shll  $1,%ecx
  addl  %edi,%ecx
  addb  (%ecx),%dl
  jmp   jbpnoflip1
jbnoflip1:
  movl  _Gfx,%esi
  shll  $3,%edx
  shll  $1,%ecx
  addl  %edi,%ecx
  subb  (%ecx),%dl
jbpnoflip1:

//col in cx
  incl  %ecx
  movl  (%ecx),%edi
  andl  $7,%edi
  movl  %edi,%ecx
  movl  _pScreen,%edi


//move pointer to source
  shll  $16,%ecx
  addl  %ecx,%esi
  shll  $6,%eax
  addl  %eax,%esi
//skip clip boundary
  cmpb  $1,_FlipScreen
  jne   jbnoflip2
  addl  $25,%ebx
  addl  $25,%edx
  jmp   jbpnoflip2
jbnoflip2:
  addl  $32,%ebx
  addl  $32,%edx
jbpnoflip2:
//move pointer to destination
  addl  %ebx,%edi
  shll  $9,%edx
  addl  %edx,%edi


  cld
  movl  $2,%edx
  movl  $504,%ebx
  movl  %edx,%ecx
//do the actual blit
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl

jbnodirt:
  popl  %edi
  popl  %esi
  popl  %edx
  popl  %ecx
  popl  %ebx
  popl  %eax


  incl  %ecx
  cmpl  $32,%ecx
  jne   jbwdthlp

  incl  %edx
  cmpl  _maxchar,%edx
  jne   jbhtlp

  jmp   jbaldone
jbrotchar:
jbhtlp2:
  xorl  %ecx,%ecx
jbwdthlp2:
  movl  %edx,%ebx
  shll  $5,%ebx
  addl  %esi,%ebx
  addl  %ecx,%ebx

  movb  (%ebx),%al
  pushl %eax
  pushl %ebx
  pushl %ecx
  pushl %edx
  pushl %esi
  pushl %edi

//dirty updates
  leal  _pacdirty,%esi
//x pos
  movl  %ecx,%ebx
  shll  $2,%ebx
  addl  %ebx,%esi

//y pos
  movl  %edx,%ebx
  shll  $7,%ebx

  addl  %ebx,%esi
//get offset
  movl  %ecx,%ebx
  shll  $1,%ebx
  addl  %edi,%ebx
//use edx as temp storage
  pushl %edx
//offset + colour
  xorl  %edx,%edx
  movw  (%ebx),%dx
  shll  $8,%edx
  movl  %edx,%ebx
  popl  %edx
//char code in bottom 8 bits
  movb  %al,%bl
  cmpl  %ebx,(%esi)
  je    jbnodirt2
//store char+offset+colour
  movl  %ebx,(%esi)


//sprite code in al
//check for extended chars (jumpbug)
  cmpl  $0,_jbugbank2
  je    jbnoextrot
  movl  %eax,%ebx
  andl  $0xc0,%ebx
  cmpl  $0x80,%ebx
  jne   jbnoextrot
  addl  _jbugmodchar,%eax
jbnoextrot:
//x in bx
  movl  %ecx,%ebx

  shll  $3,%ebx
  cmpb  $1,_FlipScreen
  jne   jbrotnoflip1
  notl  %ebx
  andl  $0xff,%ebx
  shll  $3,%edx
  movl  _FlipGfx,%esi
  jmp   jbprotnoflip1
jbrotnoflip1:
  movl  _Gfx,%esi
//y in dx
  shll  $3,%edx
jbprotnoflip1:

  shll  $1,%ecx
  addl  %edi,%ecx
  subb  (%ecx),%dl
//col in cx
  incl  %ecx
  movl  (%ecx),%edi
  andl  $7,%edi
  movl  %edi,%ecx
//blit char
  movl  _pScreen,%edi
//move pointer to source
  shll  $16,%ecx
  addl  %ecx,%esi
  shll  $6,%eax
  addl  %eax,%esi
  cmpb  $1,_FlipScreen
  jne   jbrotnoflip2
//skip clip boundary
  addl  $25,%ebx
  addl  $39,%edx
  jmp   jbprotnoflip2
jbrotnoflip2:
//skip clip boundary
  addl  $32,%ebx
//move pointer to destination
  notl  %edx
  andl  $0xff,%edx
  addl  $32,%edx
jbprotnoflip2:
  addl  %edx,%edi

  shll  $9,%ebx
  addl  %ebx,%edi

  cld
  movl  $2,%edx
  movl  $504,%ebx
  movl  %edx,%ecx

  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl

jbnodirt2:
  popl  %edi
  popl  %esi
  popl  %edx
  popl  %ecx
  popl  %ebx
  popl  %eax


  incl  %ecx
  cmpl  $32,%ecx
  jne   jbwdthlp2

  incl  %edx
  cmpl  _maxchar,%edx
  jne   jbhtlp2


jbaldone:
  popw  %es

  popa
  ret

//function to blit uniwars char
//.x pixel based offset per row
//.blanks or spaces not blitted
//.specific character extension
.globl _unidispchars
   .align 4
_unidispchars:
  pusha
//save es and set our selector and base pointers
  pushw %es
  movw  _DataSeg,%es

  movl  _pCharMem,%esi
  movl  _pAttrMem,%edi
  xorl  %eax,%eax
  movl  _startchar,%edx
  cmpl  $0,_realorient
  je    unirotchar
unihtlp:
  xorl  %ecx,%ecx
uniwdthlp:
  movl  %edx,%ebx
  shll  $5,%ebx
  addl  %esi,%ebx
  addl  %ecx,%ebx
  movb  (%ebx),%al

  pushl %eax
  pushl %ebx
  pushl %ecx
  pushl %edx
  pushl %esi
  pushl %edi

//dirty updates
  leal  _pacdirty,%esi
//x pos
  movl  %ecx,%ebx
  shll  $2,%ebx
  addl  %ebx,%esi

//y pos
  movl  %edx,%ebx
  shll  $7,%ebx

  addl  %ebx,%esi
//get offset
  movl  %ecx,%ebx
  shll  $1,%ebx
  addl  %edi,%ebx
//use edx as temp storage
  pushl %edx
//offset + colour
  xorl  %edx,%edx
  movw  (%ebx),%dx
  shll  $8,%edx
  movl  %edx,%ebx
  popl  %edx
//char code in bottom 8 bits
  movb  %al,%bl
//see if it's dirty
  cmpl  %ebx,(%esi)
  je    uninodirt
//store char+offset+colour
  movl  %ebx,(%esi)


//sprite code in al
//extended chars (uniwars)
  addl  _unimodchar,%eax
//x in bx
  movl  %ecx,%ebx
  shll  $3,%ebx
  cmpb  $1,_FlipScreen
  jne   uninoflip1
  notl  %ebx
  andl  $0xff,%ebx

  movl  _FlipGfx,%esi
  shll  $3,%edx
//y in dx
  notl  %edx
  andl  $0xff,%edx
  shll  $1,%ecx
  addl  %edi,%ecx
  addb  (%ecx),%dl
  jmp   unipnoflip1
uninoflip1:
  movl  _Gfx,%esi
  shll  $3,%edx
  shll  $1,%ecx
  addl  %edi,%ecx
  subb  (%ecx),%dl
unipnoflip1:

//col in cx
  incl  %ecx
  movl  (%ecx),%edi
  andl  $7,%edi
  movl  %edi,%ecx
  movl  _pScreen,%edi


//move pointer to source
  shll  $16,%ecx
  addl  %ecx,%esi
  shll  $6,%eax
  addl  %eax,%esi
//skip clip boundary
  cmpb  $1,_FlipScreen
  jne   uninoflip2
  addl  $25,%ebx
  addl  $25,%edx
  jmp   unipnoflip2
uninoflip2:
  addl  $32,%ebx
  addl  $32,%edx
unipnoflip2:
//move pointer to destination
  addl  %ebx,%edi
  shll  $9,%edx
  addl  %edx,%edi


  cld
  movl  $2,%edx
  movl  $504,%ebx
  movl  %edx,%ecx
//do the actual blit
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl

uninodirt:
  popl  %edi
  popl  %esi
  popl  %edx
  popl  %ecx
  popl  %ebx
  popl  %eax


  incl  %ecx
  cmpl  $32,%ecx
  jne   uniwdthlp

  incl  %edx
  cmpl  _maxchar,%edx
  jne   unihtlp

  jmp   unialdone
unirotchar:
unihtlp2:
  xorl  %ecx,%ecx
uniwdthlp2:
  movl  %edx,%ebx
  shll  $5,%ebx
  addl  %esi,%ebx
  addl  %ecx,%ebx

  movb  (%ebx),%al
  pushl %eax
  pushl %ebx
  pushl %ecx
  pushl %edx
  pushl %esi
  pushl %edi

//dirty updates
  leal  _pacdirty,%esi
//x pos
  movl  %ecx,%ebx
  shll  $2,%ebx
  addl  %ebx,%esi

//y pos
  movl  %edx,%ebx
  shll  $7,%ebx

  addl  %ebx,%esi
//get offset
  movl  %ecx,%ebx
  shll  $1,%ebx
  addl  %edi,%ebx
//use edx as temp storage
  pushl %edx
//offset + colour
  xorl  %edx,%edx
  movw  (%ebx),%dx
  shll  $8,%edx
  movl  %edx,%ebx
  popl  %edx
//char code in bottom 8 bits
  movb  %al,%bl
  cmpl  %ebx,(%esi)
  je    uninodirt2
//store char+offset+colour
  movl  %ebx,(%esi)


//sprite code in al
//extended chars (uniwars)
  addl  _unimodchar,%eax
//x in bx
  movl  %ecx,%ebx

  shll  $3,%ebx
  cmpb  $1,_FlipScreen
  jne   unirotnoflip1
  notl  %ebx
  andl  $0xff,%ebx
  shll  $3,%edx
  movl  _FlipGfx,%esi
  jmp   uniprotnoflip1
unirotnoflip1:
  movl  _Gfx,%esi
//y in dx
  shll  $3,%edx
uniprotnoflip1:

  shll  $1,%ecx
  addl  %edi,%ecx
  subb  (%ecx),%dl
//col in cx
  incl  %ecx
  movl  (%ecx),%edi
  andl  $7,%edi
  movl  %edi,%ecx
//blit char
  movl  _pScreen,%edi
//move pointer to source
  shll  $16,%ecx
  addl  %ecx,%esi
  shll  $6,%eax
  addl  %eax,%esi
  cmpb  $1,_FlipScreen
  jne   unirotnoflip2
//skip clip boundary
  addl  $25,%ebx
  addl  $39,%edx
  jmp   uniprotnoflip2
unirotnoflip2:
//skip clip boundary
  addl  $32,%ebx
//move pointer to destination
  notl  %edx
  andl  $0xff,%edx
  addl  $32,%edx
uniprotnoflip2:
  addl  %edx,%edi

  shll  $9,%ebx
  addl  %ebx,%edi

  cld
  movl  $2,%edx
  movl  $504,%ebx
  movl  %edx,%ecx

  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl
  addl  %ebx,%edi
  movl  %edx,%ecx
  rep
  movsl

uninodirt2:
  popl  %edi
  popl  %esi
  popl  %edx
  popl  %ecx
  popl  %ebx
  popl  %eax


  incl  %ecx
  cmpl  $32,%ecx
  jne   uniwdthlp2

  incl  %edx
  cmpl  _maxchar,%edx
  jne   unihtlp2


unialdone:
  popw  %es

  popa
  ret

