#ifndef _CONTROL_H_
#define _CONTROL_H_

#define JOYSET(x) \
{ \
   if(joyidx[ x ]!=-1) \
   { \
      joykeys[joyidx[ x ]]=128; \
      lowkeys[joyidx[ x ]]=128; \
   } \
}

#define JOYCLEAR(x) \
{ \
   if(joyidx[ x ]!=-1) \
   { \
      if(joykeys[joyidx[ x ]]) \
      { \
         joykeys[joyidx[ x ]]=0; \
         lowkeys[joyidx[ x ]]=0; \
      } \
   } \
}

#define JOYDIRSET(x) \
{ \
   joykeys[ x ]=128; \
   lowkeys[ x ]=128; \
}

#define JOYDIRCLEAR(x) \
{ \
   if(joykeys[ x ]) \
   { \
      joykeys[ x ]=0; \
      lowkeys[ x ]=0; \
   } \
}


#define JOY_NONE        0
#define JOY_2BUTTON     1
#define JOY_4BUTTON     2
#define JOY_6BUTTON     3
#define JOY_8BUTTON     4
#define JOY_SIDEWIND    5
#define JOY_GAMEPADPRO  6
#define JOY_PSXPAD      7

#define NO_JOY_CONFIGS  20

void getdefjoy(void);
void savedefjoy(void);
void savegamejoy(void);

void checkcontroller(void);
void handlejoystick(void);
void calibratejoy(void);
void readstandardjoy(void);
void readsidewinder(void);
void readgamepadpro(void);
void readpsxpad(void);
void setgenjoy(unsigned long int inval,int joyidx,unsigned long int *dirs,unsigned long int *buts);

#endif
