#ifndef _DOCASTLE_MEM_H_
#define _DOCASTLE_MEM_H_

struct MemoryWriteByte DoCastleWrite[] =
{
   {0x0000,0x7fff,romwrite,NULL},
   {0xa000,0xa008,docastlesharedw1,NULL},
   {0xe000,0xe000,docastlenmi,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct MemoryReadByte DoCastleRead[] =
{
   {0xb800,0xbfff,docastlemir2,NULL},
   {0xa000,0xa008,docastlesharedr,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct MemoryWriteByte DoCastleWrite2[] =
{
   {0x0000,0x3fff,romwrite,NULL},
   {0xa000,0xa008,docastlesharedw,NULL},
   {0xc004,0xc004,docastle_flipscreen_off_w,NULL},
   {0xc007,0xc007,romwrite,NULL},
   {0xc084,0xc084,docastle_flipscreen_on_w,NULL},
   {0xc087,0xc087,romwrite,NULL},
   {0xe000,0xe000,SN76496_0_w,NULL},
   {0xe400,0xe400,SN76496_1_w,NULL},
   {0xe800,0xe800,SN76496_2_w,NULL},
   {0xec00,0xec00,SN76496_3_w,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};



struct MemoryReadByte DoCastleRead2[] =
{
   {0xa000,0xa008,docastlesharedr1,NULL},
   {0xc001,0xc001,dip3,NULL},
   {0xc002,0xc002,dip2,NULL},
   {0xc004,0xc004,docastle_flipscreen_off_r,NULL},
   {0xc007,0xc007,dip1,NULL},
   {0xc081,0xc081,dip3,NULL},
   {0xc082,0xc082,dip2,NULL},
   {0xc083,0xc083,docastlemir,NULL},
   {0xc084,0xc084,docastle_flipscreen_on_r,NULL},
   {0xc085,0xc085,docastlemir,NULL},
   {0xc087,0xc087,dip1,NULL},

   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct MemoryWriteByte JJackWrite[] =
{
   {0x0000,0x1fff,romwrite,NULL},
   {0x4000,0x9fff,romwrite,NULL},
   {0xa000,0xa008,docastlesharedw1,NULL},
   {0xb800,0xb800,docastlenmi,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};


struct MemoryReadByte JJackRead[] =
{
   {0xa000,0xa008,docastlesharedr,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct MemoryWriteByte JJackWrite2[] =
{
   {0x0000,0x3fff,romwrite,NULL},
   {0xa000,0xa000,SN76496_0_w,NULL},
   {0xa400,0xa400,SN76496_1_w,NULL},
   {0xa800,0xa800,SN76496_2_w,NULL},
   {0xac00,0xac00,SN76496_3_w,NULL},
   {0xc004,0xc004,docastle_flipscreen_off_w,NULL},
   {0xc084,0xc084,docastle_flipscreen_on_w,NULL},
   {0xe000,0xe008,docastlesharedw,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct MemoryReadByte JJackRead2[] =
{
   {0xc001,0xc001,dip3,NULL},
   {0xc002,0xc002,dip2,NULL},
   {0xc004,0xc004,docastle_flipscreen_off_r,NULL},
   {0xc007,0xc007,dip1,NULL},
   {0xc081,0xc081,dip3,NULL},
   {0xc082,0xc082,dip2,NULL},
   {0xc083,0xc083,docastlemir,NULL},
   {0xc084,0xc084,docastle_flipscreen_on_r,NULL},
   {0xc085,0xc085,docastlemir,NULL},
   {0xc087,0xc087,dip1,NULL},
   {0xe000,0xe008,docastlesharedr1,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};



#endif
