#ifndef _GYRODINE_MEM_H_
#define _GYRODINE_MEM_H_

//Main_PortMap( gyrodine, 0x00 )

struct z80PortRead GyroReadPorts[] =
{
   {(UINT16)0xffff,     (UINT16)0xffff, NULL,NULL}
};

struct z80PortWrite GyroWritePorts[] =
{
   {0,0,gyrointenable,NULL},
   {1,1,gyroflipscreen,NULL},
   {2,2,gyrosubcontrol,NULL},
   {(UINT16)0xffff,     (UINT16)0xffff, NULL,NULL}
};

//Sub_PortMap( gyrodine, 0x00, 0xc0 )
struct z80PortRead GyroReadPorts2[] =
{
   {2,2,AY8910_read_port_0_r,NULL},
   {(UINT16)0xffff,     (UINT16)0xffff, NULL,NULL}
};

struct z80PortWrite GyroWritePorts2[] =
{
   {0,0,AY8910_control_port_0_w,NULL},
   {1,1,AY8910_write_port_0_w,NULL},
   {0xc0,0xc0,AY8910_control_port_1_w,NULL},
   {0xc1,0xc1,AY8910_write_port_1_w,NULL},
   {(UINT16)0xffff,     (UINT16)0xffff, NULL,NULL}
};

//Main_MemMap( gyrodine, 0xf000, 0xe000 )
  // #define Main_MemMap( name, shared, watchdog )

struct MemoryWriteByte GyroWrite[] =
{
   {0x0000,0x7fff,romwrite,NULL},
//   {0x8000,0x87ff,videoram_w, &videoram, &videoram_size },
//      {0x8800,0x8fff,colorram_w,&colorram },
  //    {0x9000,0x97ff,MWA_RAM,&kyugo_videoram, &kyugo_videoram_size },
//      {0x9800,0x9fff,MWA_RAM,&spriteram_2 },   /* 4 bits wide */
  //    {0xa000,0xa7ff,MWA_RAM,&spriteram, &spriteram_size },
    //  {0xa800,0xa800,MWA_RAM,&kyugo_back_scrollY_lo }, /* back scroll Y */
//      {0xb000,0xb000,kyugo_gfxctrl_w }, /* back scroll MSB + other stuff */
  //    {0xb800,0xb800,MWA_RAM, &kyugo_back_scrollX }, /* back scroll X */
  // {0xf000,0xf7ff,gyrosharew,NULL},
   //{0xf800,0xffff,gyrosharew,NULL},
//      {watchdog,watchdog, watchdog_reset_w },
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};


struct MemoryReadByte GyroRead[] =
{
   //{ 0x8000, 0x87ff, videoram_r },
   //{ 0x8800, 0x8fff, colorram_r },
   //{ 0x9000, 0x97ff, MRA_RAM }, /* foreground tiles */
   {0x9800,0x9fff,gyrosram,NULL},
//   {0xa000,0xa7ff,MRA_RAM }, /* sprites */
//   {0xf000,0xf7ff,gyrosharer,NULL},
   //{0xf800,0xffff,gyrosharer,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};


struct MemoryWriteByte GyroWrite2[] =
{
   {0x0000,0x1fff,romwrite,NULL},
//   {0x4000,0x47ff,gyrosharew,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

//Sub_MemMap( gyrodine, 0x1fff, 0x4000, 0x0000, 0x8080, 0x8040, 0x8000 )
//#define Sub_MemMap( name, rom_end, shared, extra_ram, in0, in1, in2 )
//   static struct MemoryWriteAddress name##_sub_writemem[] = {
//      { 0x0000, rom_end, MWA_ROM },
//      { shared, shared+0x7ff, shared_ram_w }, /* shared RAM */
//      { extra_ram, extra_ram+0x7ff, MWA_RAM }, /* extra RAM */
//      { -1 }   /* end of table */
//   };


struct MemoryReadByte GyroRead2[] =
{
   {0x4000,0x47ff,gyrosharer,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

//Sub_MemMap( gyrodine, 0x1fff, 0x4000, 0x0000, 0x8080, 0x8040, 0x8000 )
//#define Sub_MemMap( name, rom_end, shared, extra_ram, in0, in1, in2 )
  // static struct MemoryReadAddress name##_sub_readmem[] = {
    //  { 0x0000, rom_end, MRA_ROM },
//      { shared, shared+0x7ff, shared_ram_r }, /* shared RAM */
  //    { extra_ram, extra_ram+0x7ff, MRA_RAM }, /* extra RAM */
//      { in0, in0, input_port_2_r }, /* input port */
//      { in1, in1, input_port_3_r }, /* input port */
//      { in2, in2, input_port_4_r }, /* input port */
//      { -1 }   /* end of table */
//   };


#endif
