#include "main.h"
#include "ldybvid.h"
#include "globals.h"
#include "twk.h"

static int vblank=0;

void initladybug(void)
{
}

void ladybugupdscreen(void)
{
   int x,y;
   pBYTE pWork;
   pBYTE pWork2;
   int spr,preidx;
   int idx,idx2;

   pWork=&pCode[0xd000];
   pWork2=&pCode[0xd400];
   if(realorient)
   {
      if(FlipScreen)
      {
         for(y=0;y<32;y++)
         {
            for(x=0;x<32;x++,pWork++,pWork2++)
            {
               spr=*pWork;
               spr|=(*pWork2&0x08)<<5;
               dispchar((x<<3)+8,(y<<3)+8,spr,((*pWork2)&0x0f));
            }
         }
      }
      else
      {
         for(y=0;y<32;y++)
         {
            for(x=0;x<32;x++,pWork++,pWork2++)
            {
               spr=*pWork;
               spr|=(*pWork2&0x08)<<5;
               dispchar(256-(x<<3),256-(y<<3),spr,((*pWork2)&0x0f));
            }
         }
      }


      if(ror)
      {
         for(idx=0x7380;idx>=0x7080;idx-=0x40)
         {
            idx2=0;
            while(idx2<0x40&&pCode[idx+idx2]!=0)
               idx2+=4;
            while(idx2>0)
            {
               idx2-=4;
               preidx=idx+idx2;
               if(pCode[preidx]&0x40)
                     sprblit(
                     256-(247-pCode[preidx+3]), //x
                     256-(255-(((idx-0x7000)>>2)-1+(pCode[preidx]&0x0f))), //y
                     (pCode[preidx+1]>>2)+((pCode[preidx+2]&0x10)<<2),
                     pCode[preidx+2]&0x0f,
                     !(pCode[preidx]&0x20),
                     pCode[preidx]&0x10
                     );
            }
         }
      }
      else
      {
         for(idx=0x7380;idx>=0x7080;idx-=0x40)
         {
            idx2=0;
            while(idx2<0x40&&pCode[idx+idx2]!=0)
               idx2+=4;
            while(idx2>0)
            {
               idx2-=4;
               preidx=idx+idx2;
               if(pCode[preidx]&0x40)
                     sprblit(
                     247-pCode[preidx+3], //x
                     255-(((idx-0x7000)>>2)-1+(pCode[preidx]&0x0f)), //y
                     (pCode[preidx+1]>>2)+((pCode[preidx+2]&0x10)<<2),
                     pCode[preidx+2]&0x0f,
                     pCode[preidx]&0x20,
                     !(pCode[preidx]&0x10)
                     );
            }
         }
      }
   }
   else
   {
      if(FlipScreen)
      {
         for(y=0;y<32;y++)
         {
            for(x=0;x<32;x++,pWork++,pWork2++)
            {
               spr=*pWork;
               spr|=(*pWork2&0x08)<<5;
               dispchar((255+7)-((y<<3)+7),(x<<3)+8,spr,((*pWork2)&0x0f));
            }
         }
      }
      else
      {
         for(y=0;y<32;y++)
         {
            for(x=0;x<32;x++,pWork++,pWork2++)
            {
               spr=*pWork;
               spr|=(*pWork2&0x08)<<5;
               dispchar((y<<3)+7,256-(x<<3),spr,((*pWork2)&0x0f));
            }
         }
      }


      if(flipxy)
      {
         for(idx=0x7380;idx>=0x7080;idx-=0x40)
         {
            idx2=0;
            while(idx2<0x40&&pCode[idx+idx2]!=0)
               idx2+=4;
            while(idx2>0)
            {
               idx2-=4;
               preidx=idx+idx2;
               if(pCode[preidx]&0x40)
                     sprblit(
                     254-(((idx-0x7000)>>2)-1+(pCode[preidx]&0x0f)), //x
                     255-(247-pCode[preidx+3]), //y
                     (pCode[preidx+1]>>2)+((pCode[preidx+2]&0x10)<<2),
                     (pCode[preidx+2]&0x0f),
                     (pCode[preidx]&0x10),
                     !(pCode[preidx]&0x20)
                     );
            }
         }
      }
      else
      {
         for(idx=0x7380;idx>=0x7080;idx-=0x40)
         {
            idx2=0;
            while(idx2<0x40&&pCode[idx+idx2]!=0)
               idx2+=4;
            while(idx2>0)
            {
               idx2-=4;
               preidx=idx+idx2;
               if(pCode[preidx]&0x40)
                     sprblit(
                     ((idx-0x7000)>>2)-1+(pCode[preidx]&0x0f), //x
                     248-pCode[preidx+3], //y
                     (pCode[preidx+1]>>2)+((pCode[preidx+2]&0x10)<<2),
                     pCode[preidx+2]&0x0f,
                     !(pCode[preidx]&0x10),
                     pCode[preidx]&0x20
                     );
            }
         }
      }
   }
}

void ladybugsetpal(pBYTE pIn)
{
   int idx;
   int bit0,bit1,bit2,bit3;

   for(idx=0;idx<32;idx++)
	{
      outportb(0x3c8,idx);
      bit0=((~pIn[idx])&0x01)*0x47;
      bit1=((~pIn[idx]>>5)&0x01)*0x97;
      outportb(0x3c9,(bit0+bit1)>>2);
      bit0=((~pIn[idx]>>2)&0x01)*0x47;
      bit1=((~pIn[idx]>>6)&0x01)*0x97;
      outportb(0x3c9,(bit0+bit1)>>2);
      bit0=((~pIn[idx]>>4)&0x01)*0x47;
      bit1=((~pIn[idx]>>7)&0x01)*0x97;
      outportb(0x3c9,(bit0+bit1)>>2);
	}
//chars
   for(idx=0;idx<8;idx++)
	{
      collookups[0][(idx<<2)]=0;
      collookups[0][(idx<<2)+1]=idx+0x08;
      collookups[0][(idx<<2)+2]=idx+0x10;
      collookups[0][(idx<<2)+3]=idx+0x18;
	}
   pIn+=32;
//sprites
   for(idx=0;idx<32;idx++)
	{
      bit0=(pIn[idx]>>3)&0x01;
      bit1=(pIn[idx]>>2)&0x01;
      bit2=(pIn[idx]>>1)&0x01;
      bit3=(pIn[idx])&0x01;
      collookups[1][idx]=bit0+(bit1<<1)+(bit2<<2)+(bit3<<3);
	}

}

UINT8 ladybugnop(UINT32 offset, struct MemoryReadByte * mrb)
{
   return 0;
}


UINT8 ladybugvb(UINT32 offset, struct MemoryReadByte * mrb)
{
   UINT8 ret=pCode[offset]&0x3f;
//vague vblankness
   if(getcyclesthisframe()>400)
      vblank=0;
   if(vblank)
      ret|=0x40;
   else
      ret|=0x80;

   return ret;
}

void ladybugint(void)
{
   vblank=1;
   if(pCode[0x10000]&1)
      mz80nmi();
   if(pCode[0x10000]&2)
      mz80int(0xff);
}

void ladybugreset(void)
{
}

void clearladybug(void)
{
}
