#include "main.h"
#include "mrdovid.h"
#include "globals.h"
#include "twk.h"
#include "ui.h"

static int mdscroll;

static int mrdotiledirty[32*32];

void initmrdo(void)
{
}

void clearmrdo(void)
{
}



void mrdosetpal(pBYTE pIn)
{
   int i;
   int idx1,idx2;
   int bit0,bit1,bit2,bit3;

   for(i=0;i<256;i++)
	{
      outportb(0x3c8,i);

      idx1=((i>>3)&0x1c)+(i&0x03)+32;
      idx2=(i&0x1c)+(i&0x03);

      bit0=((pIn[idx1]>>1)&0x01)*0x2c;
      bit1=(pIn[idx1]&0x01)*0x37;
      bit2=((pIn[idx2]>>1)&0x01)*0x43;
      bit3=(pIn[idx2]&0x01)*0x59;
      outportb(0x3c9,(bit0+bit1+bit2+bit3)>>2);

      bit0=((pIn[idx1]>>3)&0x01)*0x2c;
      bit1=((pIn[idx1]>>2)&0x01)*0x37;
      bit2=((pIn[idx2]>>3)&0x01)*0x43;
      bit3=((pIn[idx2]>>2)&0x01)*0x59;
      outportb(0x3c9,(bit0+bit1+bit2+bit3)>>2);

      bit0=((pIn[idx1]>>5)&0x01)*0x2c;
      bit1=((pIn[idx1]>>4)&0x01)*0x37;
      bit2=((pIn[idx2]>>5)&0x01)*0x43;
      bit3=((pIn[idx2]>>4)&0x01)*0x59;
      outportb(0x3c9,(bit0+bit1+bit2+bit3)>>2);
	}
   pIn+=0x40;
   for(i=0;i<64;i++)
	{
		int bits;
      if(i<32)
         bits=pIn[i]&0x0f;
      else
         bits=pIn[i&0x1f]>>4;

      collookups[0][i]=bits+((bits&0x0c)<<3);
	}

}


void mrdoupdatescreen(void)
{
   int x,y,col,idx,spr;
   pBYTE pWork;
   pBYTE pWork2;
   unsigned char xx=0;
   static int mdone;
   int prey=0;


   if(!mdone)
   {
      resetgame();
      mdone=1;
   }


   if(realorient)
   {
      if(FlipScreen)
      {
         pWork=&pCode[0x8400];
         pWork2=&pCode[0x8000];

         for(y=0;y<32;y++)
         {
            xx=((unsigned char)(y<<3)-mdscroll);
            for(x=0;x<32;x++,pWork++,pWork2++)
            {
               spr=(*pWork|512)+((*pWork2&0x80)<<1);
               col=*pWork2&0x3f;
               if(*pWork2&0x40)
                  dispopqchar((x<<3)+7,xx,spr,col);
               else
                  dispchar((x<<3)+7,xx,spr,col);
            }
         }

         pWork=&pCode[0x8c00];
         pWork2=&pCode[0x8800];

         for(y=0;y<32;y++)
         {
            for(x=0;x<32;x++,pWork++,pWork2++)
            {
               col=*pWork2&0x3f;
               spr=*pWork+((*pWork2&0x80)<<1);
               if(*pWork2&0x40)
                  dispchar((x<<3)+7,(y<<3),spr,col);
               else
                  disptranschar((x<<3)+7,(y<<3),spr,col);
            }
         }
      }
      else
      {
         pWork=&pCode[0x8400];
         pWork2=&pCode[0x8000];

         for(y=0;y<32;y++)
         {
            xx=((unsigned char)(255-(y<<3))+mdscroll);
            for(x=0;x<32;x++,pWork++,pWork2++)
            {
               spr=(*pWork|512)+((*pWork2&0x80)<<1);
               col=*pWork2&0x3f;
               if(*pWork2&0x40)
                  dispopqchar(255-(x<<3),xx-6,spr,col);
               else
                  dispchar(255-(x<<3),xx-6,spr,col);
            }
         }

         pWork=&pCode[0x8c40];
         pWork2=&pCode[0x8840];

         for(y=2;y<30;y++)
         {
            for(x=0;x<32;x++,pWork++,pWork2++)
            {
               col=*pWork2&0x3f;
               spr=*pWork+((*pWork2&0x80)<<1);
               if(*pWork2&0x40)
                  dispchar(255-(x<<3),248-(y<<3),spr,col);
               else
                  disptranschar(255-(x<<3),248-(y<<3),spr,col);
            }
         }
      }
      if(ror)
      {
         for(idx=0x90fc;idx>=0x9000;idx-=4)
         {
            if(pCode[idx+1]!=0)
               sprblit(pCode[idx+3]+7,256-pCode[idx+1],pCode[idx],pCode[idx+2]&0x0f,!(pCode[idx+2]&0x10),(pCode[idx+2]&0x20));
         }
      }
      else
      {
         for(idx=0x90fc;idx>=0x9000;idx-=4)
         {
            if(pCode[idx+1]!=0)
               sprblit(247-pCode[idx+3],pCode[idx+1]-15,pCode[idx],pCode[idx+2]&0x0f,(pCode[idx+2]&0x10),!(pCode[idx+2]&0x20));
         }
      }
   }
   else
   {
      if(FlipScreen)
      {
         pWork=&pCode[0x8400];
         pWork2=&pCode[0x8000];

         for(y=0;y<32;y++)
         {
            xx=((unsigned char)(((248-(y<<3))+mdscroll)));
            for(x=0;x<32;x++,pWork++,pWork2++)
            {
               spr=(*pWork|512)+((*pWork2&0x80)<<1);
               col=*pWork2&0x3f;
               if(*pWork2&0x40)
                  dispopqchar(xx,(x<<3)+8,spr,col);
               else
                  dispchar(xx,(x<<3)+8,spr,col);
            }
         }

         pWork=&pCode[0x8c40];
         pWork2=&pCode[0x8840];

         for(y=2;y<30;y++)
         {
            for(x=0;x<32;x++,pWork++,pWork2++)
            {
               col=*pWork2&0x3f;
               spr=*pWork+((*pWork2&0x80)<<1);
               if(*pWork2&0x40)
                  dispchar(248-(y<<3),(x<<3)+8,spr,col);
               else
                  disptranschar(248-(y<<3),(x<<3)+8,spr,col);
            }
         }
      }
      else
      {
         pWork=&pCode[0x8400];
         pWork2=&pCode[0x8000];

         for(y=0;y<32;y++)
         {
            xx=((unsigned char)(255-((255-(y<<3))+mdscroll)));
            for(x=0;x<32;x++,pWork++,pWork2++)
            {
               spr=(*pWork|512)+((*pWork2&0x80)<<1);
               col=*pWork2&0x3f;
               if(*pWork2&0x40)
                  dispopqchar(xx,255-(x<<3),spr,col);
               else
                  dispchar(xx,255-(x<<3),spr,col);
            }
         }

         pWork=&pCode[0x8c40];
         pWork2=&pCode[0x8840];

         for(y=2;y<30;y++)
         {
            for(x=0;x<32;x++,pWork++,pWork2++)
            {
               col=*pWork2&0x3f;
               spr=*pWork+((*pWork2&0x80)<<1);
               if(*pWork2&0x40)
                  dispchar((y<<3),255-(x<<3),spr,col);
               else
                  disptranschar((y<<3),255-(x<<3),spr,col);
            }
         }
      }
      if(flipxy)
      {
         for(idx=0x90fc;idx>=0x9000;idx-=4)
         {
            if(pCode[idx+1]!=0)
               sprblit(pCode[idx+1]-16,pCode[idx+3]+8,pCode[idx],pCode[idx+2]&0x0f,(pCode[idx+2]&0x20),!(pCode[idx+2]&0x10));
         }
      }
      else
      {
         for(idx=0x90fc;idx>=0x9000;idx-=4)
         {
            if(pCode[idx+1]!=0)
               sprblit(255-pCode[idx+1],247-pCode[idx+3],pCode[idx],pCode[idx+2]&0x0f,!(pCode[idx+2]&0x20),(pCode[idx+2]&0x10));
         }
      }
   }
}

void mrdoreset(void)
{
}


void mrdoint(void)
{
}

UINT8 mrdoprot(UINT32 offset, struct MemoryReadByte *mrb)
{
   struct mz80context mdcontext;
   mz80GetContext(&mdcontext);

   return pCode[mdcontext.z80hl.hl];
}


void mrdoscroll(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   mdscroll=value;
}

