#include "main.h"
#include "pengovid.h"
#include "globals.h"

extern int pacidx1;
extern int pacidxbase1;
extern int pacidx2;
extern int pacbank;
static int pengointen=0;

void initpengo2u(void)
{
   pacidx1=0x8ffe;
   pacidxbase1=0x8ff0;
   pacidx2=0x902e;
   pacbank=0;
}


void pengoint(void)
{

   if(pCode[0x9040])
      mz80int(0xff);
}

void pengogfxbankw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   pacbank=value&1;
}

void pengosetpal(pBYTE pIn)
{
   int idx,inner;
   int bit0,bit1,bit2;

   for(idx=0;idx<32;idx++)
   {
      outportb(0x3c8,idx);
//red
      bit0=(*pIn&1)*0x21;
      bit1=((*pIn>>1)&1)*0x47;
      bit2=((*pIn>>2)&1)*0x97;
      outportb(0x3c9,(bit0+bit1+bit2)>>2);
//green
      bit0=((*pIn>>3)&1)*0x21;
      bit1=((*pIn>>4)&1)*0x47;
      bit2=((*pIn>>5)&01)*0x97;
      outportb(0x3c9,(bit0+bit1+bit2)>>2);
//blue
      bit0=0;
      bit1=((*pIn>>6)&1)*0x47;
      bit2=((*pIn>>7)&1)*0x97;
      outportb(0x3c9,(bit0+bit1+bit2)>>2);
      pIn++;
	}
   for(idx=0;idx<128;idx++)
      collookups[0][idx]=*(pIn++)&0x0f;
   pIn+=0x80;
   for(idx=0;idx<128;idx++)
	{
      if(*pIn)
         collookups[1][idx]=((*pIn)&0x0f)+0x10;
      else
         collookups[1][idx]=0;
      pIn++;
	}

}

